public class Pawn extends Piece{
        private boolean once, end ;

        public Pawn(Cell cell, Color color) {
                super(cell, color) ;
                this.once = true ;
                this.end = false ;
        }

        public void setOnce(boolean once) {
                this.once = once;
        }

        public void setEnd(boolean end) {
                this.end = end;
        }

        @Override
        public boolean isValidMove(Cell c, Cell board[][], Piece pw[], Piece pb[]) {
                if (super.isDeleted()) return false ;
                if (super.getColor()==Color.BLACK && super.getCell().getRow()==0) end = true ;
                if (super.getColor()==Color.WHITE && super.getCell().getRow()==7) end = true ;

                int sw=0 ;
                if (super.getColor() == Color.BLACK) {
                        for (Piece p:pw) {
                                if (!p.isDeleted() && p.getCell().getRow()==c.getRow() && p.getCell().getCol()==c.getCol()) sw=1 ;
                        }
                }
                else {
                        for (Piece p:pb) {
                                if (!p.isDeleted() && p.getCell().getRow()==c.getRow() && p.getCell().getCol()==c.getCol()) sw=1 ;
                        }
                }

                if (once) {
                        //once = false ;
                        //System.out.println("row: " + this.getCell().getRow()) ;
                        //System.out.println("col: " + this.getCell().getCol()) ;
                        if ((this.getCell().getCol() == c.getCol()) &&
                                (Math.abs(this.getCell().getRow()-c.getRow())==1 || Math.abs(this.getCell().getRow()-c.getRow())==2)
                                && c.isEmpty())
                                return true ;
                        else return false ;
                }
                else {
                        if (end) {
                                if(
                                        ((this.getCell().getCol() == c.getCol()) &&
                                                (Math.abs(this.getCell().getRow()-c.getRow())==1)) ||
                                                (Math.abs(this.getCell().getCol()-c.getCol())==Math.abs(this.getCell().getRow()-c.getRow()) &&
                                                        Math.abs(this.getCell().getCol()-c.getCol())==1 && sw==1)
                                        ) return true ;
                                else return false ;
                        }
                        else {
                                if(
                                        (this.getCell().getCol() == c.getCol() &&
                                                ((this.getCell().getRow()-c.getRow()==1 && super.getColor()==Color.BLACK) ||
                                                        (this.getCell().getRow()-c.getRow()==-1 && super.getColor()==Color.WHITE)) )
                                                ||
                                                (Math.abs(this.getCell().getCol()-c.getCol())==Math.abs(this.getCell().getRow()-c.getRow()) &&
                                                        ((this.getCell().getRow()-c.getRow()==1 && super.getColor()==Color.BLACK && sw==1) ||
                                                                (this.getCell().getRow()-c.getRow()==-1 && super.getColor()==Color.WHITE && sw==1)) )
                                        ) return true ;
                                else return false ;
                        }
                }
        }
}
