public abstract class Piece {

    private Cell cell ;
    private Color color ;
    private boolean deleted ;

    public Piece (Cell cell, Color color) {
        this.cell = cell ;
        this.cell.setEmpty(false) ;
        this.color = color ;
        this.deleted = false ;
    }

    public abstract boolean isValidMove(Cell c, Cell board[][], Piece pw[], Piece pb[]) ;

    public Cell getCell() {
        return cell;
    }

    public Color getColor() {
        return color;
    }

    public boolean isDeleted() {
        return deleted;
    }

    public void setCell(Cell cell) {
        this.cell = cell;
    }

    public void setColor(Color color) {
        this.color = color;
    }

    public void setDeleted(boolean deleted) {
        this.deleted = deleted;
    }

}
